/* Sistemas Integrados TECNISA

Nome: 02CU_GERTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   28/04/2006 - Pedro Viol
*/

CREATE OR REPLACE TRIGGER LOG_SUP_IMPCOLET
AFTER DELETE OR INSERT OR UPDATE
ON IMPCOLET FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      V_DESC         := 'Alquota = ' || ' ' || :NEW.VRALIQIMPCOL || ' ' || 'Perc. Base Calc. = ' || :NEW.VRPERRBCALCO || ' ' ||
                        'Valor Imposto = ' || ' ' || :NEW.VRIMPCOLETA || ' ' || 'Valor Base Calc. = ' || ' ' || :NEW.VRBASECALCOL || ' ' ||
                        'Valor Parc. Ded. = ' || ' ' || :NEW.VRPARCDEDCOL || ' ' || 'Cd. Fiscal = ' || ' ' || :NEW.CDFISCITMCOL || ' ' ||
                        'Valor Imp. Acres./Desc. = ' || ' ' || :NEW.VRADIMPCOL;

      V_ITPESQ       := :NEW.CDFILIAL || :NEW.NRCOLEPRECO || :NEW.CDMARCA || :NEW.CDREGIAO ||
                        :NEW.CDFORNECED || :NEW.CDPRODUTO || :NEW.CDIMPOSTO;

      V_CDFILLOGOPER := :NEW.CDFILIAL;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC      := 'Alquota = ' || ' ' || :NEW.VRALIQIMPCOL || ' ' || 'Perc. Base Calc. = ' || :NEW.VRPERRBCALCO || ' ' ||
                        'Valor Imposto = ' || ' ' || :NEW.VRIMPCOLETA || ' ' || 'Valor Base Calc. = ' || ' ' || :NEW.VRBASECALCOL || ' ' ||
                        'Valor Parc. Ded. = ' || ' ' || :NEW.VRPARCDEDCOL || ' ' || 'Cd. Fiscal = ' || ' ' || :NEW.CDFISCITMCOL || ' ' ||
                        'Valor Imp. Acres./Desc. = ' || ' ' || :NEW.VRADIMPCOL;

         V_ITPESQ     := :NEW.CDFILIAL || :NEW.NRCOLEPRECO || :NEW.CDMARCA || :NEW.CDREGIAO ||
                         :NEW.CDFORNECED || :NEW.CDPRODUTO || :NEW.CDIMPOSTO;

         V_CDFILLOGOPER := :NEW.CDFILIAL;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   := 'Alquota = ' || ' ' || :OLD.VRALIQIMPCOL || ' ' || 'Perc. Base Calc. = ' || :OLD.VRPERRBCALCO || ' ' ||
                        'Valor Imposto = ' || ' ' || :OLD.VRIMPCOLETA || ' ' || 'Valor Base Calc. = ' || ' ' || :OLD.VRBASECALCOL || ' ' ||
                        'Valor Parc. Ded. = ' || ' ' || :OLD.VRPARCDEDCOL || ' ' || 'Cd. Fiscal = ' || ' ' || :OLD.CDFISCITMCOL || ' ' ||
                        'Valor Imp. Acres./Desc. = ' || ' ' || :OLD.VRADIMPCOL;

            V_ITPESQ := :OLD.CDFILIAL || :OLD.NRCOLEPRECO || :OLD.CDMARCA || :OLD.CDREGIAO ||
                        :OLD.CDFORNECED || :OLD.CDPRODUTO || :OLD.CDIMPOSTO;

            V_CDFILLOGOPER := :OLD.CDFILIAL;
            V_IDTIPOOPER   := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER,
       CDFILLOGOPER)
   VALUES
      ('IMPCOLET',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       V_CDFILLOGOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_SUP_IMPCOLET','4.07.051'); END;
/

